// SPDX-License-Identifier: ISC
//
// Copyright (c) 2008, Mukunda Johnson (mukunda@maxmod.org)

/****************************************************************************
 *                                                          __              *
 *                ____ ___  ____ __  ______ ___  ____  ____/ /              *
 *               / __ `__ \/ __ `/ |/ / __ `__ \/ __ \/ __  /               *
 *              / / / / / / /_/ />  </ / / / / / /_/ / /_/ /                *
 *             /_/ /_/ /_/\__,_/_/|_/_/ /_/ /_/\____/\__,_/                 *
 *                                                                          *
 *               Nintendo DS & Gameboy Advance Sound System                 *
 *                                                                          *
 ****************************************************************************/

// MAXMOD SOUNDBANK FORMAT DEFINITIONS

#ifndef MM_MSL_H
#define MM_MSL_H

#ifdef __cplusplus
extern "C" {
#endif

#include "mm_types.h"

typedef struct tmslhead
{
	mm_hword	sampleCount;
	mm_hword	moduleCount;
	mm_word		reserved[2];
	mm_addr		sampleTable[MSL_NSAMPS];
	mm_addr		moduleTable[MSL_NSONGS];
} msl_head;

#ifdef __cplusplus
}
#endif

#endif // MM_MSL_H
